Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## org.mortbay.jetty
Class Request

    java.lang.Object
      org.mortbay.jetty.Request

All Implemented Interfaces:
  HttpServletRequest, ServletRequest

Direct Known Subclasses:
  Ajp13Request

    public class Request

extends Object
implements HttpServletRequest

Jetty Request.

Implements `HttpServletRequest` from the `javax.servlet` package.

The standard interface of mostly getters, is extended with setters so that the request is mutable by the handlers that it is passed to. This allows the request object to be as lightweight as possible and not actually implement any significant behaviour. For example

- The `getContextPath` method will return null, until the requeset has been passed to a `ContextHandler` which matches the `getPathInfo` with a context path and calls `setContextPath` as a result.
- the HTTP session methods will all return null sessions until such time as a request has been passed to a `SessionHandler` which checks for session cookies and enables the ability to create new sessions.
- The `getServletPath` method will return null until the request has been passed to a `ServletHandler` and the pathInfo matched against the servlet URL patterns and `setServletPath` called as a result.

A request instance is created for each `HttpConnection` accepted by the server and recycled for each HTTP request received via that connection. An effort is made to avoid reparsing headers and cookies that are likely to be the same for requests from the same connection.

Author:
  gregw

Field Summary

Fields inherited from interface javax.servlet.http.HttpServletRequest
`BASIC_AUTH, CLIENT_CERT_AUTH, DIGEST_AUTH, FORM_AUTH`

Constructor Summary
`Request(HttpConnection connection)`

Method Summary
`void` | `addEventListener(EventListener listener)`
`Object` | `getAttribute(String name)` Returns the value of the named attribute as an `Object`, or `null` if no attribute of the given name exists.
`Enumeration` | `getAttributeNames()` Returns an `Enumeration` containing the names of the attributes available to this request.
`Attributes` | `getAttributes()`
`String` | `getAuthType()` Returns the name of the authentication scheme used to protect the servlet.
`String` | `getCharacterEncoding()` Returns the name of the character encoding used in the body of this request.
`HttpConnection` | `getConnection()`
`int` | `getContentLength()` Returns the length, in bytes, of the request body and made available by the input stream, or -1 if the length is not known.
`String` | `getContentType()` Returns the MIME type of the body of the request, or `null` if the type is not known.
`ContextHandler.SContext` | `getContext()`
`String` | `getContextPath()` Returns the portion of the request URI that indicates the context of the request.
`Continuation` | `getContinuation()`
`Continuation` | `getContinuation(boolean create)`
`Cookie[]` | `getCookies()` Returns an array containing all of the `Cookie` objects the client sent with this request.
`long` | `getDateHeader(String name)` Returns the value of the specified request header as a `long` value that represents a `Date` object.
`String` | `getHeader(String name)` Returns the value of the specified request header as a `String`.
`Enumeration` | `getHeaderNames()` Returns an enumeration of all the header names this request contains.
`Enumeration` | `getHeaders(String name)` Returns all the values of the specified request header as an `Enumeration` of `String` objects.
`int` | `getInputState()`
`ServletInputStream` | `getInputStream()` Retrieves the body of the request as binary data using a `ServletInputStream`.
`int` | `getIntHeader(String name)` Returns the value of the specified request header as an `int`.
`String` | `getLocalAddr()` Returns the Internet Protocol (IP) address of the interface on which the request was received.
`Locale` | `getLocale()` Returns the preferred `Locale` that the client will accept content in, based on the Accept-Language header.
`Enumeration` | `getLocales()` Returns an `Enumeration` of `Locale` objects indicating, in decreasing order starting with the preferred locale, the locales that are acceptable to the client based on the Accept-Language header.
`String` | `getLocalName()` Returns the host name of the Internet Protocol (IP) interface on which the request was received.
`int` | `getLocalPort()` Returns the Internet Protocol (IP) port number of the interface on which the request was received.
`String` | `getMethod()` Returns the name of the HTTP method with which this request was made, for example, GET, POST, or PUT.
`String` | `getParameter(String name)` Returns the value of a request parameter as a `String`, or `null` if the parameter does not exist.
`Map` | `getParameterMap()` Returns a java.util.Map of the parameters of this request.
`Enumeration` | `getParameterNames()` Returns an `Enumeration` of `String` objects containing the names of the parameters contained in this request.
`MultiMap` | `getParameters()`
`String[]` | `getParameterValues(String name)` Returns an array of `String` objects containing all of the values the given request parameter has, or `null` if the parameter does not exist.
`String` | `getPathInfo()` Returns any extra path information associated with the URL the client sent when it made this request.
`String` | `getPathTranslated()` Returns any extra path information after the servlet name but before the query string, and translates it to a real path.
`String` | `getProtocol()` Returns the name and version of the protocol the request uses in the form protocol/majorVersion.minorVersion, for example, HTTP/1.1.
`String` | `getQueryEncoding()`
`String` | `getQueryString()` Returns the query string that is contained in the request URL after the path.
`BufferedReader` | `getReader()` Retrieves the body of the request as character data using a `BufferedReader`.
`String` | `getRealPath(String path)`
`String` | `getRemoteAddr()` Returns the Internet Protocol (IP) address of the client or last proxy that sent the request.
`String` | `getRemoteHost()` Returns the fully qualified name of the client or the last proxy that sent the request.
`int` | `getRemotePort()` Returns the Internet Protocol (IP) source port of the client or last proxy that sent the request.
`String` | `getRemoteUser()` Returns the login of the user making this request, if the user has been authenticated, or `null` if the user has not been authenticated.
`static Request` | `getRequest(HttpServletRequest request)`
`RequestDispatcher` | `getRequestDispatcher(String path)` Returns a `RequestDispatcher` object that acts as a wrapper for the resource located at the given path.
`String` | `getRequestedSessionId()` Returns the session ID specified by the client.
`String` | `getRequestURI()` Returns the part of this request's URL from the protocol name up to the query string in the first line of the HTTP request.
`StringBuffer` | `getRequestURL()` Reconstructs the URL the client used to make the request.
`Map` | `getRoleMap()`
`StringBuffer` | `getRootURL()` Reconstructs the URL the client used to make the request.
`String` | `getScheme()` Returns the name of the scheme used to make this request, for example, `http`, `https`, or `ftp`.
`String` | `getServerName()` Returns the host name of the server to which the request was sent.
`int` | `getServerPort()` Returns the port number to which the request was sent.
`String` | `getServletName()`
`String` | `getServletPath()` Returns the part of this request's URL that calls the servlet.
`HttpSession` | `getSession()` Returns the current session associated with this request, or if the request does not have a session, creates one.
`HttpSession` | `getSession(boolean create)` Returns the current `HttpSession` associated with this request or, if there is no current session and `create` is true, returns a new session.
`SessionManager` | `getSessionManager()`
`long` | `getTimeStamp()` Get Request TimeStamp
`Buffer` | `getTimeStampBuffer()` Get Request TimeStamp
`HttpURI` | `getUri()`
`Principal` | `getUserPrincipal()` Returns a `java.security.Principal` object containing the name of the current authenticated user.
`UserRealm` | `getUserRealm()`
`boolean` | `isHandled()`
`boolean` | `isRequestedSessionIdFromCookie()` Checks whether the requested session ID came in as a cookie.
`boolean` | `isRequestedSessionIdFromUrl()`
`boolean` | `isRequestedSessionIdFromURL()` Checks whether the requested session ID came in as part of the request URL.
`boolean` | `isRequestedSessionIdValid()` Checks whether the requested session ID is still valid.
`boolean` | `isSecure()` Returns a boolean indicating whether this request was made using a secure channel, such as HTTPS.
`boolean` | `isUserInRole(String role)` Returns a boolean indicating whether the authenticated user is included in the specified logical "role".
`HttpSession` | `recoverNewSession(Object key)`
`protected void` | `recycle()`
`void` | `removeAttribute(String name)` Removes an attribute from this request.
`void` | `removeEventListener(EventListener listener)`
`void` | `saveNewSession(Object key, HttpSession session)`
`void` | `setAttribute(String name, Object value)` Stores an attribute in this request.
`void` | `setAttributes(Attributes attributes)`
`void` | `setAuthType(String authType)`
`void` | `setCharacterEncoding(String encoding)` Overrides the name of the character encoding used in the body of this request.
`void` | `setCharacterEncodingUnchecked(String encoding)`
`void` | `setContentType(String contentType)`
`void` | `setContext(ContextHandler.SContext context)`
`void` | `setContextPath(String contextPath)` Sets the "context path" for this request
`void` | `setCookies(Cookie[] cookies)`
`void` | `setHandled(boolean h)`
`void` | `setMethod(String method)`
`void` | `setParameters(MultiMap parameters)`
`void` | `setPathInfo(String pathInfo)`
`void` | `setProtocol(String protocol)`
`void` | `setQueryEncoding(String queryEncoding)` Set the character encoding used for the query string.
`void` | `setQueryString(String queryString)`
`void` | `setRequestedSessionId(String requestedSessionId)`
`void` | `setRequestedSessionIdFromCookie(boolean requestedSessionIdCookie)`
`void` | `setRequestURI(String requestURI)`
`void` | `setRoleMap(Map map)`
`void` | `setScheme(String scheme)`
`void` | `setServerName(String host)`
`void` | `setServerPort(int port)`
`void` | `setServletName(String name)`
`void` | `setServletPath(String servletPath)`
`void` | `setSession(HttpSession session)`
`void` | `setSessionManager(SessionManager sessionManager)`
`void` | `setTimeStamp(long ts)`
`void` | `setUri(HttpURI uri)`
`void` | `setUserPrincipal(Principal userPrincipal)`
`void` | `setUserRealm(UserRealm userRealm)`
`String` | `toString()`

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

Constructor Detail

### Request

    public Request(HttpConnection connection)

Method Detail

### recycle

    protected void recycle()

### getTimeStampBuffer

    public Buffer getTimeStampBuffer()

  Get Request TimeStamp

  Returns:
    The time that the request was received.

### getTimeStamp

    public long getTimeStamp()

  Get Request TimeStamp

  Returns:
    The time that the request was received.

### setTimeStamp

    public void setTimeStamp(long ts)

### isHandled

    public boolean isHandled()

### setHandled

    public void setHandled(boolean h)

### getAttribute

    public Object getAttribute(String name)

  Description copied from interface: `ServletRequest`
  Returns the value of the named attribute as an `Object`, or `null` if no attribute of the given name exists.

  Attributes can be set two ways. The servlet container may set attributes to make available custom information about a request. For example, for requests made using HTTPS, the attribute `javax.servlet.request.X509Certificate` can be used to retrieve information on the certificate of the client. Attributes can also be set programatically using `ServletRequest.setAttribute(java.lang.String, java.lang.Object)`. This allows information to be embedded into a request before a `RequestDispatcher` call.

  Attribute names should follow the same conventions as package names. This specification reserves names matching `java.*`, `javax.*`, and `sun.*`.

  Specified by:
    `getAttribute` in interface `ServletRequest`
  Parameters:
    `name` - a `String` specifying the name of the attribute
  Returns:
    an `Object` containing the value of the attribute, or `null` if the attribute does not exist

### getAttributeNames

    public Enumeration getAttributeNames()

  Description copied from interface: `ServletRequest`
  Returns an `Enumeration` containing the names of the attributes available to this request. This method returns an empty `Enumeration` if the request has no attributes available to it.

  Specified by:
    `getAttributeNames` in interface `ServletRequest`
  Returns:
    an `Enumeration` of strings containing the names of the request's attributes

### getAuthType

    public String getAuthType()

  Description copied from interface: `HttpServletRequest`
  Returns the name of the authentication scheme used to protect the servlet. All servlet containers support basic, form and client certificate authentication, and may additionally support digest authentication. If the servlet is not authenticated `null` is returned.

  Same as the value of the CGI variable AUTH_TYPE.

  Specified by:
    `getAuthType` in interface `HttpServletRequest`
  Returns:
    one of the static members BASIC_AUTH, FORM_AUTH, CLIENT_CERT_AUTH, DIGEST_AUTH (suitable for == comparison) or the container-specific string indicating the authentication scheme, or `null` if the request was not authenticated.

### getCharacterEncoding

    public String getCharacterEncoding()

  Description copied from interface: `ServletRequest`
  Returns the name of the character encoding used in the body of this request. This method returns `null` if the request does not specify a character encoding

  Specified by:
    `getCharacterEncoding` in interface `ServletRequest`
  Returns:
    a `String` containing the name of the character encoding, or `null` if the request does not specify a character encoding

### getContentLength

    public int getContentLength()

  Description copied from interface: `ServletRequest`
  Returns the length, in bytes, of the request body and made available by the input stream, or -1 if the length is not known. For HTTP servlets, same as the value of the CGI variable CONTENT_LENGTH.

  Specified by:
    `getContentLength` in interface `ServletRequest`
  Returns:
    an integer containing the length of the request body or -1 if the length is not known

### getContentType

    public String getContentType()

  Description copied from interface: `ServletRequest`
  Returns the MIME type of the body of the request, or `null` if the type is not known. For HTTP servlets, same as the value of the CGI variable CONTENT_TYPE.

  Specified by:
    `getContentType` in interface `ServletRequest`
  Returns:
    a `String` containing the name of the MIME type of the request, or null if the type is not known

### setContentType

    public void setContentType(String contentType)

### getContextPath

    public String getContextPath()

  Description copied from interface: `HttpServletRequest`
  Returns the portion of the request URI that indicates the context of the request. The context path always comes first in a request URI. The path starts with a "/" character but does not end with a "/" character. For servlets in the default (root) context, this method returns "". The container does not decode this string.

  It is possible that a servlet container may match a context by more than one context path. In such cases this method will return the actual context path used by the request and it may differ from the path returned by the `ServletContext.getContextPath()` method. The context path returned by `ServletContext.getContextPath()` should be considered as the prime or preferred context path of the application.

  Specified by:
    `getContextPath` in interface `HttpServletRequest`
  Returns:
    a `String` specifying the portion of the request URI that indicates the context of the request
  See Also:
    `ServletContext.getContextPath()`

### getCookies

    public Cookie[] getCookies()

  Description copied from interface: `HttpServletRequest`
  Returns an array containing all of the `Cookie` objects the client sent with this request. This method returns `null` if no cookies were sent.

  Specified by:
    `getCookies` in interface `HttpServletRequest`
  Returns:
    an array of all the `Cookies` included with this request, or `null` if the request has no cookies

### getDateHeader

    public long getDateHeader(String name)

  Description copied from interface: `HttpServletRequest`
  Returns the value of the specified request header as a `long` value that represents a `Date` object. Use this method with headers that contain dates, such as `If-Modified-Since`.

  The date is returned as the number of milliseconds since January 1, 1970 GMT. The header name is case insensitive.

  If the request did not have a header of the specified name, this method returns -1. If the header can't be converted to a date, the method throws an `IllegalArgumentException`.

  Specified by:
    `getDateHeader` in interface `HttpServletRequest`
  Parameters:
    `name` - a `String` specifying the name of the header
  Returns:
    a `long` value representing the date specified in the header expressed as the number of milliseconds since January 1, 1970 GMT, or -1 if the named header was not included with the request

### getHeader

    public String getHeader(String name)

  Description copied from interface: `HttpServletRequest`
  Returns the value of the specified request header as a `String`. If the request did not include a header of the specified name, this method returns `null`. If there are multiple headers with the same name, this method returns the first head in the request. The header name is case insensitive. You can use this method with any request header.

  Specified by:
    `getHeader` in interface `HttpServletRequest`
  Parameters:
    `name` - a `String` specifying the header name
  Returns:
    a `String` containing the value of the requested header, or `null` if the request does not have a header of that name

### getHeaderNames

    public Enumeration getHeaderNames()

  Description copied from interface: `HttpServletRequest`
  Returns an enumeration of all the header names this request contains. If the request has no headers, this method returns an empty enumeration.

  Some servlet containers do not allow servlets to access headers using this method, in which case this method returns `null`

  Specified by:
    `getHeaderNames` in interface `HttpServletRequest`
  Returns:
    an enumeration of all the header names sent with this request; if the request has no headers, an empty enumeration; if the servlet container does not allow servlets to use this method, `null`

### getHeaders

    public Enumeration getHeaders(String name)

  Description copied from interface: `HttpServletRequest`
  Returns all the values of the specified request header as an `Enumeration` of `String` objects.

  Some headers, such as `Accept-Language` can be sent by clients as several headers each with a different value rather than sending the header as a comma separated list.

  If the request did not include any headers of the specified name, this method returns an empty `Enumeration`. The header name is case insensitive. You can use this method with any request header.

  Specified by:
    `getHeaders` in interface `HttpServletRequest`
  Parameters:
    `name` - a `String` specifying the header name
  Returns:
    an `Enumeration` containing the values of the requested header. If the request does not have any headers of that name return an empty enumeration. If the container does not allow access to header information, return null

### getInputStream

    public ServletInputStream getInputStream()
                                      throws IOException

  Description copied from interface: `ServletRequest`
  Retrieves the body of the request as binary data using a `ServletInputStream`. Either this method or `ServletRequest.getReader()` may be called to read the body, not both.

  Specified by:
    `getInputStream` in interface `ServletRequest`
  Returns:
    a `ServletInputStream` object containing the body of the request
  Throws:
    `IOException` - if an input or output exception occurred

### getIntHeader

    public int getIntHeader(String name)

  Description copied from interface: `HttpServletRequest`
  Returns the value of the specified request header as an `int`. If the request does not have a header of the specified name, this method returns -1. If the header cannot be converted to an integer, this method throws a `NumberFormatException`.

  The header name is case insensitive.

  Specified by:
    `getIntHeader` in interface `HttpServletRequest`
  Parameters:
    `name` - a `String` specifying the name of a request header
  Returns:
    an integer expressing the value of the request header or -1 if the request doesn't have a header of this name

### getLocalAddr

    public String getLocalAddr()

  Description copied from interface: `ServletRequest`
  Returns the Internet Protocol (IP) address of the interface on which the request was received.

  Specified by:
    `getLocalAddr` in interface `ServletRequest`
  Returns:
    a `String` containing the IP address on which the request was received.

### getLocale

    public Locale getLocale()

  Description copied from interface: `ServletRequest`
  Returns the preferred `Locale` that the client will accept content in, based on the Accept-Language header. If the client request doesn't provide an Accept-Language header, this method returns the default locale for the server.

  Specified by:
    `getLocale` in interface `ServletRequest`
  Returns:
    the preferred `Locale` for the client

### getLocales

    public Enumeration getLocales()

  Description copied from interface: `ServletRequest`
  Returns an `Enumeration` of `Locale` objects indicating, in decreasing order starting with the preferred locale, the locales that are acceptable to the client based on the Accept-Language header. If the client request doesn't provide an Accept-Language header, this method returns an `Enumeration` containing one `Locale`, the default locale for the server.

  Specified by:
    `getLocales` in interface `ServletRequest`
  Returns:
    an `Enumeration` of preferred `Locale` objects for the client

### getLocalName

    public String getLocalName()

  Description copied from interface: `ServletRequest`
  Returns the host name of the Internet Protocol (IP) interface on which the request was received.

  Specified by:
    `getLocalName` in interface `ServletRequest`
  Returns:
    a `String` containing the host name of the IP on which the request was received.

### getLocalPort

    public int getLocalPort()

  Description copied from interface: `ServletRequest`
  Returns the Internet Protocol (IP) port number of the interface on which the request was received.

  Specified by:
    `getLocalPort` in interface `ServletRequest`
  Returns:
    an integer specifying the port number

### getMethod

    public String getMethod()

  Description copied from interface: `HttpServletRequest`
  Returns the name of the HTTP method with which this request was made, for example, GET, POST, or PUT. Same as the value of the CGI variable REQUEST_METHOD.

  Specified by:
    `getMethod` in interface `HttpServletRequest`
  Returns:
    a `String` specifying the name of the method with which this request was made

### getParameter

    public String getParameter(String name)

  Description copied from interface: `ServletRequest`
  Returns the value of a request parameter as a `String`, or `null` if the parameter does not exist. Request parameters are extra information sent with the request. For HTTP servlets, parameters are contained in the query string or posted form data.

  You should only use this method when you are sure the parameter has only one value. If the parameter might have more than one value, use `ServletRequest.getParameterValues(java.lang.String)`.

  If you use this method with a multivalued parameter, the value returned is equal to the first value in the array returned by `getParameterValues`.

  If the parameter data was sent in the request body, such as occurs with an HTTP POST request, then reading the body directly via `ServletRequest.getInputStream()` or `ServletRequest.getReader()` can interfere with the execution of this method.

  Specified by:
    `getParameter` in interface `ServletRequest`
  Parameters:
    `name` - a `String` specifying the name of the parameter
  Returns:
    a `String` representing the single value of the parameter
  See Also:
    `ServletRequest.getParameterValues(java.lang.String)`

### getParameterMap

    public Map getParameterMap()

  Description copied from interface: `ServletRequest`
  Returns a java.util.Map of the parameters of this request. Request parameters are extra information sent with the request. For HTTP servlets, parameters are contained in the query string or posted form data.

  Specified by:
    `getParameterMap` in interface `ServletRequest`
  Returns:
    an immutable java.util.Map containing parameter names as keys and parameter values as map values. The keys in the parameter map are of type String. The values in the parameter map are of type String array.

### getParameterNames

    public Enumeration getParameterNames()

  Description copied from interface: `ServletRequest`
  Returns an `Enumeration` of `String` objects containing the names of the parameters contained in this request. If the request has no parameters, the method returns an empty `Enumeration`.

  Specified by:
    `getParameterNames` in interface `ServletRequest`
  Returns:
    an `Enumeration` of `String` objects, each `String` containing the name of a request parameter; or an empty `Enumeration` if the request has no parameters

### getParameterValues

    public String[] getParameterValues(String name)

  Description copied from interface: `ServletRequest`
  Returns an array of `String` objects containing all of the values the given request parameter has, or `null` if the parameter does not exist.

  If the parameter has a single value, the array has a length of 1.

  Specified by:
    `getParameterValues` in interface `ServletRequest`
  Parameters:
    `name` - a `String` containing the name of the parameter whose value is requested
  Returns:
    an array of `String` objects containing the parameter's values
  See Also:
    `ServletRequest.getParameter(java.lang.String)`

### getPathInfo

    public String getPathInfo()

  Description copied from interface: `HttpServletRequest`
  Returns any extra path information associated with the URL the client sent when it made this request. The extra path information follows the servlet path but precedes the query string and will start with a "/" character.

  This method returns `null` if there was no extra path information.

  Same as the value of the CGI variable PATH_INFO.

  Specified by:
    `getPathInfo` in interface `HttpServletRequest`
  Returns:
    a `String`, decoded by the web container, specifying extra path information that comes after the servlet path but before the query string in the request URL; or `null` if the URL does not have any extra path information

### getPathTranslated

    public String getPathTranslated()

  Description copied from interface: `HttpServletRequest`
  Returns any extra path information after the servlet name but before the query string, and translates it to a real path. Same as the value of the CGI variable PATH_TRANSLATED.

  If the URL does not have any extra path information, this method returns `null` or the servlet container cannot translate the virtual path to a real path for any reason (such as when the web application is executed from an archive). The web container does not decode this string.

  Specified by:
    `getPathTranslated` in interface `HttpServletRequest`
  Returns:
    a `String` specifying the real path, or `null` if the URL does not have any extra path information

### getProtocol

    public String getProtocol()

  Description copied from interface: `ServletRequest`
  Returns the name and version of the protocol the request uses in the form protocol/majorVersion.minorVersion, for example, HTTP/1.1. For HTTP servlets, the value returned is the same as the value of the CGI variable `SERVER_PROTOCOL`.

  Specified by:
    `getProtocol` in interface `ServletRequest`
  Returns:
    a `String` containing the protocol name and version number

### getReader

    public BufferedReader getReader()
                             throws IOException

  Description copied from interface: `ServletRequest`
  Retrieves the body of the request as character data using a `BufferedReader`. The reader translates the character data according to the character encoding used on the body. Either this method or `ServletRequest.getInputStream()` may be called to read the body, not both.

  Specified by:
    `getReader` in interface `ServletRequest`
  Returns:
    a `BufferedReader` containing the body of the request
  Throws:
    `IOException` - if an input or output exception occurred
  See Also:
    `ServletRequest.getInputStream()`

### getRealPath

    public String getRealPath(String path)

  Specified by:
    `getRealPath` in interface `ServletRequest`

### getRemoteAddr

    public String getRemoteAddr()

  Description copied from interface: `ServletRequest`
  Returns the Internet Protocol (IP) address of the client or last proxy that sent the request. For HTTP servlets, same as the value of the CGI variable `REMOTE_ADDR`.

  Specified by:
    `getRemoteAddr` in interface `ServletRequest`
  Returns:
    a `String` containing the IP address of the client that sent the request

### getRemoteHost

    public String getRemoteHost()

  Description copied from interface: `ServletRequest`
  Returns the fully qualified name of the client or the last proxy that sent the request. If the engine cannot or chooses not to resolve the hostname (to improve performance), this method returns the dotted-string form of the IP address. For HTTP servlets, same as the value of the CGI variable `REMOTE_HOST`.

  Specified by:
    `getRemoteHost` in interface `ServletRequest`
  Returns:
    a `String` containing the fully qualified name of the client

### getRemotePort

    public int getRemotePort()

  Description copied from interface: `ServletRequest`
  Returns the Internet Protocol (IP) source port of the client or last proxy that sent the request.

  Specified by:
    `getRemotePort` in interface `ServletRequest`
  Returns:
    an integer specifying the port number

### getRemoteUser

    public String getRemoteUser()

  Description copied from interface: `HttpServletRequest`
  Returns the login of the user making this request, if the user has been authenticated, or `null` if the user has not been authenticated. Whether the user name is sent with each subsequent request depends on the browser and type of authentication. Same as the value of the CGI variable REMOTE_USER.

  Specified by:
    `getRemoteUser` in interface `HttpServletRequest`
  Returns:
    a `String` specifying the login of the user making this request, or `null` if the user login is not known

### getRequestDispatcher

    public RequestDispatcher getRequestDispatcher(String path)

  Description copied from interface: `ServletRequest`
  Returns a `RequestDispatcher` object that acts as a wrapper for the resource located at the given path. A `RequestDispatcher` object can be used to forward a request to the resource or to include the resource in a response. The resource can be dynamic or static.

  The pathname specified may be relative, although it cannot extend outside the current servlet context. If the path begins with a "/" it is interpreted as relative to the current context root. This method returns `null` if the servlet container cannot return a `RequestDispatcher`.

  The difference between this method and `ServletContext.getRequestDispatcher(java.lang.String)` is that this method can take a relative path.

  Specified by:
    `getRequestDispatcher` in interface `ServletRequest`
  Parameters:
    `path` - a `String` specifying the pathname to the resource. If it is relative, it must be relative against the current servlet.
  Returns:
    a `RequestDispatcher` object that acts as a wrapper for the resource at the specified path, or `null` if the servlet container cannot return a `RequestDispatcher`
  See Also:
    `RequestDispatcher`, `ServletContext.getRequestDispatcher(java.lang.String)`

### getRequestedSessionId

    public String getRequestedSessionId()

  Description copied from interface: `HttpServletRequest`
  Returns the session ID specified by the client. This may not be the same as the ID of the current valid session for this request. If the client did not specify a session ID, this method returns `null`.

  Specified by:
    `getRequestedSessionId` in interface `HttpServletRequest`
  Returns:
    a `String` specifying the session ID, or `null` if the request did not specify a session ID
  See Also:
    `HttpServletRequest.isRequestedSessionIdValid()`

### getRequestURI

    public String getRequestURI()

  Description copied from interface: `HttpServletRequest`
  Returns the part of this request's URL from the protocol name up to the query string in the first line of the HTTP request. The web container does not decode this String. For example:

  First line of HTTP request | Returned Value
  --- | ---
  POST /some/path.html HTTP/1.1 |  | /some/path.html
  GET http://foo.bar/a.html HTTP/1.0 |  | /a.html
  HEAD /xyz?a=b HTTP/1.1 |  | /xyz

  To reconstruct an URL with a scheme and host, use `HttpUtils.getRequestURL(javax.servlet.http.HttpServletRequest)`.

  Specified by:
    `getRequestURI` in interface `HttpServletRequest`
  Returns:
    a `String` containing the part of the URL from the protocol name up to the query string
  See Also:
    `HttpUtils.getRequestURL(javax.servlet.http.HttpServletRequest)`

### getRequestURL

    public StringBuffer getRequestURL()

  Description copied from interface: `HttpServletRequest`
  Reconstructs the URL the client used to make the request. The returned URL contains a protocol, server name, port number, and server path, but it does not include query string parameters.

  If this request has been forwarded using `RequestDispatcher.forward(javax.servlet.ServletRequest, javax.servlet.ServletResponse)`, the server path in the reconstructed URL must reflect the path used to obtain the RequestDispatcher, and not the server path specified by the client.

  Because this method returns a `StringBuffer`, not a string, you can modify the URL easily, for example, to append query parameters.

  This method is useful for creating redirect messages and for reporting errors.

  Specified by:
    `getRequestURL` in interface `HttpServletRequest`
  Returns:
    a `StringBuffer` object containing the reconstructed URL

### getScheme

    public String getScheme()

  Description copied from interface: `ServletRequest`
  Returns the name of the scheme used to make this request, for example, `http`, `https`, or `ftp`. Different schemes have different rules for constructing URLs, as noted in RFC 1738.

  Specified by:
    `getScheme` in interface `ServletRequest`
  Returns:
    a `String` containing the name of the scheme used to make this request

### getServerName

    public String getServerName()

  Description copied from interface: `ServletRequest`
  Returns the host name of the server to which the request was sent. It is the value of the part before ":" in the `Host` header value, if any, or the resolved server name, or the server IP address.

  Specified by:
    `getServerName` in interface `ServletRequest`
  Returns:
    a `String` containing the name of the server

### getServerPort

    public int getServerPort()

  Description copied from interface: `ServletRequest`
  Returns the port number to which the request was sent. It is the value of the part after ":" in the `Host` header value, if any, or the server port where the client connection was accepted on.

  Specified by:
    `getServerPort` in interface `ServletRequest`
  Returns:
    an integer specifying the port number

### getServletPath

    public String getServletPath()

  Description copied from interface: `HttpServletRequest`
  Returns the part of this request's URL that calls the servlet. This path starts with a "/" character and includes either the servlet name or a path to the servlet, but does not include any extra path information or a query string. Same as the value of the CGI variable SCRIPT_NAME.

  This method will return an empty string ("") if the servlet used to process this request was matched using the "/*" pattern.

  Specified by:
    `getServletPath` in interface `HttpServletRequest`
  Returns:
    a `String` containing the name or path of the servlet being called, as specified in the request URL, decoded, or an empty string if the servlet used to process the request is matched using the "/*" pattern.

### getServletName

    public String getServletName()

### getSession

    public HttpSession getSession()

  Description copied from interface: `HttpServletRequest`
  Returns the current session associated with this request, or if the request does not have a session, creates one.

  Specified by:
    `getSession` in interface `HttpServletRequest`
  Returns:
    the `HttpSession` associated with this request
  See Also:
    `HttpServletRequest.getSession(boolean)`

### getSession

    public HttpSession getSession(boolean create)

  Description copied from interface: `HttpServletRequest`
  Returns the current `HttpSession` associated with this request or, if there is no current session and `create` is true, returns a new session.

  If `create` is `false` and the request has no valid `HttpSession`, this method returns `null`.

  To make sure the session is properly maintained, you must call this method before the response is committed. If the container is using cookies to maintain session integrity and is asked to create a new session when the response is committed, an IllegalStateException is thrown.

  Specified by:
    `getSession` in interface `HttpServletRequest`
  Parameters:
    `create` - `true` to create a new session for this request if necessary; `false` to return `null` if there's no current session
  Returns:
    the `HttpSession` associated with this request or `null` if `create` is `false` and the request has no valid session
  See Also:
    `HttpServletRequest.getSession()`

### getUserPrincipal

    public Principal getUserPrincipal()

  Description copied from interface: `HttpServletRequest`
  Returns a `java.security.Principal` object containing the name of the current authenticated user. If the user has not been authenticated, the method returns `null`.

  Specified by:
    `getUserPrincipal` in interface `HttpServletRequest`
  Returns:
    a `java.security.Principal` containing the name of the user making this request; `null` if the user has not been authenticated

### getQueryString

    public String getQueryString()

  Description copied from interface: `HttpServletRequest`
  Returns the query string that is contained in the request URL after the path. This method returns `null` if the URL does not have a query string. Same as the value of the CGI variable QUERY_STRING.

  Specified by:
    `getQueryString` in interface `HttpServletRequest`
  Returns:
    a `String` containing the query string or `null` if the URL contains no query string. The value is not decoded by the container.

### isRequestedSessionIdFromCookie

    public boolean isRequestedSessionIdFromCookie()

  Description copied from interface: `HttpServletRequest`
  Checks whether the requested session ID came in as a cookie.

  Specified by:
    `isRequestedSessionIdFromCookie` in interface `HttpServletRequest`
  Returns:
    `true` if the session ID came in as a cookie; otherwise, `false`
  See Also:
    `HttpServletRequest.getSession(boolean)`

### isRequestedSessionIdFromUrl

    public boolean isRequestedSessionIdFromUrl()

  Specified by:
    `isRequestedSessionIdFromUrl` in interface `HttpServletRequest`

### isRequestedSessionIdFromURL

    public boolean isRequestedSessionIdFromURL()

  Description copied from interface: `HttpServletRequest`
  Checks whether the requested session ID came in as part of the request URL.

  Specified by:
    `isRequestedSessionIdFromURL` in interface `HttpServletRequest`
  Returns:
    `true` if the session ID came in as part of a URL; otherwise, `false`
  See Also:
    `HttpServletRequest.getSession(boolean)`

### isRequestedSessionIdValid

    public boolean isRequestedSessionIdValid()

  Description copied from interface: `HttpServletRequest`
  Checks whether the requested session ID is still valid.

  If the client did not specify any session ID, this method returns `false`.

  Specified by:
    `isRequestedSessionIdValid` in interface `HttpServletRequest`
  Returns:
    `true` if this request has an id for a valid session in the current session context; `false` otherwise
  See Also:
    `HttpServletRequest.getRequestedSessionId()`, `HttpServletRequest.getSession(boolean)`, `HttpSessionContext`

### isSecure

    public boolean isSecure()

  Description copied from interface: `ServletRequest`
  Returns a boolean indicating whether this request was made using a secure channel, such as HTTPS.

  Specified by:
    `isSecure` in interface `ServletRequest`
  Returns:
    a boolean indicating if the request was made using a secure channel

### isUserInRole

    public boolean isUserInRole(String role)

  Description copied from interface: `HttpServletRequest`
  Returns a boolean indicating whether the authenticated user is included in the specified logical "role". Roles and role membership can be defined using deployment descriptors. If the user has not been authenticated, the method returns `false`.

  Specified by:
    `isUserInRole` in interface `HttpServletRequest`
  Parameters:
    `role` - a `String` specifying the name of the role
  Returns:
    a `boolean` indicating whether the user making this request belongs to a given role; `false` if the user has not been authenticated

### removeAttribute

    public void removeAttribute(String name)

  Description copied from interface: `ServletRequest`
  Removes an attribute from this request. This method is not generally needed as attributes only persist as long as the request is being handled.

  Attribute names should follow the same conventions as package names. Names beginning with `java.*`, `javax.*`, and `com.sun.*`, are reserved for use by Sun Microsystems.

  Specified by:
    `removeAttribute` in interface `ServletRequest`
  Parameters:
    `name` - a `String` specifying the name of the attribute to remove

### setAttribute

    public void setAttribute(String name,
                             Object value)

  Description copied from interface: `ServletRequest`
  Stores an attribute in this request. Attributes are reset between requests. This method is most often used in conjunction with `RequestDispatcher`.

  Attribute names should follow the same conventions as package names. Names beginning with `java.*`, `javax.*`, and `com.sun.*`, are reserved for use by Sun Microsystems.
  If the object passed in is null, the effect is the same as calling `ServletRequest.removeAttribute(java.lang.String)`.
  It is warned that when the request is dispatched from the servlet resides in a different web application by `RequestDispatcher`, the object set by this method may not be correctly retrieved in the caller servlet.

  Specified by:
    `setAttribute` in interface `ServletRequest`
  Parameters:
    `name` - a `String` specifying the name of the attribute
    `value` - the `Object` to be stored

### setCharacterEncoding

    public void setCharacterEncoding(String encoding)
                              throws UnsupportedEncodingException

  Description copied from interface: `ServletRequest`
  Overrides the name of the character encoding used in the body of this request. This method must be called prior to reading request parameters or reading input using getReader(). Otherwise, it has no effect.

  Specified by:
    `setCharacterEncoding` in interface `ServletRequest`
  Parameters:
    `encoding` - `String` containing the name of the character encoding.
  Throws:
    `UnsupportedEncodingException` - if this ServletRequest is still in a state where a character encoding may be set, but the specified encoding is invalid

### setCharacterEncodingUnchecked

    public void setCharacterEncodingUnchecked(String encoding)

### setServerName

    public void setServerName(String host)

  Parameters:
    `host` - The host to set.

### setServerPort

    public void setServerPort(int port)

  Parameters:
    `host` - The host to set.

### getUri

    public HttpURI getUri()

  Returns:
    Returns the uri.

### setUri

    public void setUri(HttpURI uri)

  Parameters:
    `uri` - The uri to set.

### getConnection

    public HttpConnection getConnection()

  Returns:
    Returns the connection.

### getInputState

    public int getInputState()

  Returns:
    Returns the inputState.

### setAuthType

    public void setAuthType(String authType)

  Parameters:
    `authType` - The authType to set.

### setCookies

    public void setCookies(Cookie[] cookies)

  Parameters:
    `cookies` - The cookies to set.

### setMethod

    public void setMethod(String method)

  Parameters:
    `method` - The method to set.

### setPathInfo

    public void setPathInfo(String pathInfo)

  Parameters:
    `pathInfo` - The pathInfo to set.

### setProtocol

    public void setProtocol(String protocol)

  Parameters:
    `protocol` - The protocol to set.

### setRequestedSessionId

    public void setRequestedSessionId(String requestedSessionId)

  Parameters:
    `requestedSessionId` - The requestedSessionId to set.

### getSessionManager

    public SessionManager getSessionManager()

  Returns:
    Returns the sessionManager.

### setSessionManager

    public void setSessionManager(SessionManager sessionManager)

  Parameters:
    `sessionManager` - The sessionManager to set.

### setRequestedSessionIdFromCookie

    public void setRequestedSessionIdFromCookie(boolean requestedSessionIdCookie)

  Parameters:
    `requestedSessionIdCookie` - The requestedSessionIdCookie to set.

### setSession

    public void setSession(HttpSession session)

  Parameters:
    `session` - The session to set.

### setScheme

    public void setScheme(String scheme)

  Parameters:
    `scheme` - The scheme to set.

### setQueryString

    public void setQueryString(String queryString)

  Parameters:
    `queryString` - The queryString to set.

### setRequestURI

    public void setRequestURI(String requestURI)

  Parameters:
    `requestURI` - The requestURI to set.

### setContextPath

    public void setContextPath(String contextPath)

  Sets the "context path" for this request

  See Also:
    `HttpServletRequest.getContextPath()`

### setServletPath

    public void setServletPath(String servletPath)

  Parameters:
    `servletPath` - The servletPath to set.

### setServletName

    public void setServletName(String name)

  Parameters:
    `name` - The servletName to set.

### setUserPrincipal

    public void setUserPrincipal(Principal userPrincipal)

  Parameters:
    `userPrincipal` - The userPrincipal to set.

### setContext

    public void setContext(ContextHandler.SContext context)

  Parameters:
    `context` -

### getContext

    public ContextHandler.SContext getContext()

  Returns:
    The current `context` used for this request, or `null` if `setContext(org.mortbay.jetty.handler.ContextHandler.SContext)` has not yet been called.

### getRootURL

    public StringBuffer getRootURL()

  Reconstructs the URL the client used to make the request. The returned URL contains a protocol, server name, port number, and, but it does not include a path.

  Because this method returns a `StringBuffer`, not a string, you can modify the URL easily, for example, to append path and query parameters. This method is useful for creating redirect messages and for reporting errors.

  Returns:
    "scheme://host:port"

### getAttributes

    public Attributes getAttributes()

### setAttributes

    public void setAttributes(Attributes attributes)

### getContinuation

    public Continuation getContinuation()

### getContinuation

    public Continuation getContinuation(boolean create)

### getParameters

    public MultiMap getParameters()

  Returns:
    Returns the parameters.

### setParameters

    public void setParameters(MultiMap parameters)

  Parameters:
    `parameters` - The parameters to set.

### toString

    public String toString()

  Overrides:
    `toString` in class `Object`

### getRequest

    public static Request getRequest(HttpServletRequest request)

### addEventListener

    public void addEventListener(EventListener listener)

### removeEventListener

    public void removeEventListener(EventListener listener)

### saveNewSession

    public void saveNewSession(Object key,
                               HttpSession session)

### recoverNewSession

    public HttpSession recoverNewSession(Object key)

### getUserRealm

    public UserRealm getUserRealm()

  Returns:
    Returns the userRealm.

### setUserRealm

    public void setUserRealm(UserRealm userRealm)

  Parameters:
    `userRealm` - The userRealm to set.

### getQueryEncoding

    public String getQueryEncoding()

### setQueryEncoding

    public void setQueryEncoding(String queryEncoding)

  Set the character encoding used for the query string. This call will effect the return of getQueryString and getParamaters. It must be called before any geParameter methods. The request attribute "org.mortbay.jetty.Request.queryEncoding" may be set as an alternate method of calling setQueryEncoding.

  Parameters:
    `queryEncoding` -

### setRoleMap

    public void setRoleMap(Map map)

### getRoleMap

    public Map getRoleMap()

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright © 2007 Mort Bay Consulting. All Rights Reserved.